# Mobi Copilot Demo Android 版

<p align="center">

<a href=""><img src="https://img.shields.io/badge/platform-Android 5+-brightgreen.svg"></a>
<a href=""><img src="https://img.shields.io/badge/language-Java-green.svg"></a>

</p>

## 概述

本示例应用演示了魔笔 Copilot SDK 在 Android 端的集成方式和功能路由的使用方法。

## 魔笔平台搭建 Copilot 应用

访问 [魔笔控制台](https://mobinext.console.aliyun.com/)，通过 App Copilot Template 应用模版创建一个 Copilot 应用，发布应用到开发环境或生产环境。
应用发布后从查看环境信息，获取应用地址。

![](image/appUrl.jpg)

## SDK 依赖配置

1. settings.gradle 中的 dependencyResolutionManagement repositories 添加 `maven { url "https://maven.aliyun.com/nexus/content/repositories/releases" }`。
2. demo/build.gradle 中的 dependencies 添加 `implementation 'com.aliyun.mobi:mobi-copilot:1.0.0'`。

## SDK 使用说明

demo/src/main/java/com/mobi/demo/CopilotFragment.java 中展示了 Mobi Copilot SDK 的使用方法。

1. `import com.mobi.sdk.MobiCopilot;` 引入 MobiCopilot 类。
2. `WebView webView = view.findViewById(R.id.webView);` 获取 WebView 实例。
3. `setWebView` 配置 WebView 实例。
4. `setUrl` 配置 copilot 应用发布后的地址。
5. `setCustomRouter` 配置功能路由回调，其中 `navigateTo` 用于处理功能路由跳转，`onNavigateError`用于处理功能路由异常。
6. `setAuthToken` 配置初始 authToken，仅用于生产环境。
7. `mobiCopilot.loadCopilot` 用于启动 Copilot 应用，可传入 `MobiCopilot.MobiErrorListener` 实例用于定义 Copilot 应用运行时错误的处理逻辑。
8. `mobiCopilot.updateAuthToken` 用于更新 authToken，仅用于生产环境。

## authToken

- 开发环境应用无需 authToken。
- 生产环境应用需要通过 [魔笔 OpenAPI](https://help.aliyun.com/zh/mobi/generatenativeusertoken) 获取 authToken。
  应用初始化时需要通过 `setAuthToken` 配置初始 authToken。
  authToken 过期时间为 300 秒，需要在过期时间内重新获取，通过 `mobiCopilot.updateAuthToken` 设置新的 authToken。

## 兼容性

本 Demo 和 SDK 本身兼容 Android 5+，由于需要在 WebView 中运行 Copilot 应用，客户端提供的 WebView 版本将直接影响 Copilot 应用的运行。
目前，Copilot 应用兼容 com.google.android.webview 80 以上版本。
我们将持续优化 Copilot 应用兼容性并实时生效，您的 Android 应用无需更新。

## 注意事项

- CopilotFragment 中注册的 navigateTo 方法仅适配于通过 App Copilot Template 应用模板创建的应用中的功能路由配置，如修改了功能路由配置，请更新 navigateTo 方法以处理不同路由标识和路由参数的跳转行为。
- 如 Android Studio 提示 gradle 插件不兼容，可更新 Android Studio 或尝试降低 gradle/libs.versions.toml 中的插件版本。
